<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve the question 5 solution.</p>
		<button onclick="spiralMatrix()">print spiral matrix</button>
		<p id="demo"></p>

		<script>
			function spiralMatrix() {
				var m,n;
                var k,l;
                var i,j,p;
				var output = "";
				var test_case = prompt("Please enter no of test case : ");
				for(p=0;p<test_case;p++) {
					m = +(prompt(`Please enter no of row of matrices for ${p+1} test: `));
					n = +(prompt(`Please enter no of colum of matrices for ${p+1} test: `));
                    var finalArray = [];
                    var array = new Array(m);
                    for(i=0;i<m;i++)
                    {
                        array[i] = new Array(n);
                        for(j=0;j<n;j++)
                        {
                            array[i][j] = +(prompt(`Please enter [${i}][${j}] element for ${p+1} test:`));
                        }
                    }
                    k = 0;
                    l = 0;
                    while(k<m && l<n)
                    {
                        for(i=0;i<n;i++)
                            finalArray.push(array[k][i]);
                        k++;
                        for(i=k;i<m;i++)
                            finalArray.push(array[i][n-1]);
                        n--;
                        if(k<m)
                        {
                            for(i=n-1;i>=l;i--)
                                finalArray.push(array[m-1][i]);
                            m--;
                        }
                        if(l<n)
                        {
                            for(i=m-1;i>k;i--)
                            {
                                finalArray.push(array[i][l]);
                            }
                            l++;
                        }
                    }
                    output += `Your ${p+1} spiral matrix : `+finalArray+"<br><br><br>";
				}	
				document.getElementById("demo").innerHTML = output;
			}
		</script>

	</body>
</html>